/*
 * hd.c
 *
 *       Hexa dump utility  /CsB/
 */

#include <stdio.h>
#include <ctype.h>

int values[16];
int address;
FILE *inputfp;

main(argc,argv)
  int argc;
  char **argv;
{
  int i;

  if (argc == 1) hexadump(stdin);
  if (argc > 1) 
     for (i=1;i<argc;i++) {
           inputfp=fopen(argv[i],"r");
           if (inputfp != NULL) {
               if (argc > 2) printf("%s:\n",argv[i]);
               hexadump(inputfp);
               fclose(inputfp); }
             else {
               printf("Cannot open : %s \n",argv[i]); }
                 }
}

hexadump(fp)
  FILE *fp;
{
  int i;
  int c;

    i=0;
    address=0;
    while ((c=getc(fp)) != EOF) {
      if (i==16) { kiir(i);
                 i=0; }
      values[i]=c;
      i=i+1;
      address=address+1; }
    if (i!=0) kiir(i);
} 

kiir(x)
  int x;
{
  int j;
  char fmt[100];
  
  printf("%6ld   ",address-x); 
  for (j=0;j<16;j++) {
    if (j==8) printf("  ");
    if (x > j) {
                  sprintf(fmt,"%2x",values[j]);
                  if (fmt[0]==32 ) fmt[0]=48 ;
                  if (islower(fmt[0])) fmt[0]=toupper(fmt[0]);
                  if (islower(fmt[1])) fmt[1]=toupper(fmt[1]);
                  printf("%2s ",fmt);
               }
         else  printf("   "); }
  printf("  ");
  for (j=0;j<16;j++) {
    if (x>j) {
               if (isprint(values[j])) printf("%c",values[j]);
                                 else  printf("."); }
           else printf("  "); }
  printf("\n");
}
